# SwaggerClient-php
This is a sample Petstore server.  You can find out more about Swagger at [http://swagger.io](http://swagger.io) or on [irc.freenode.net, #swagger](http://swagger.io/irc/).

This PHP package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 1.0.0
- Build package: io.swagger.codegen.v3.generators.php.PhpClientCodegen

## Requirements

PHP 5.5 and later

## Installation & Usage
### Composer

To install the bindings via [Composer](http://getcomposer.org/), add the following to `composer.json`:

```
{
  "repositories": [
    {
      "type": "git",
      "url": "https://github.com/GIT_USER_ID/GIT_REPO_ID.git"
    }
  ],
  "require": {
    "GIT_USER_ID/GIT_REPO_ID": "*@dev"
  }
}
```

Then run `composer install`

### Manual Installation

Download the files and include `autoload.php`:

```php
    require_once('/path/to/SwaggerClient-php/vendor/autoload.php');
```

## Tests

To run the unit tests:

```
composer install
./vendor/bin/phpunit
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');


$apiInstance = new Swagger\Client\Api\DefaultApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);

try {
    $result = $apiInstance->testMethod();
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling DefaultApi->testMethod: ', $e->getMessage(), PHP_EOL;
}
?>
```

## Documentation for API Endpoints

All URIs are relative to */*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*DefaultApi* | [**testMethod**](docs/Api/DefaultApi.md#testmethod) | **GET** /test | 
*PetApi* | [**addParrot**](docs/Api/PetApi.md#addparrot) | **POST** /parrot | Add a new parrow to the store
*PetApi* | [**addPet**](docs/Api/PetApi.md#addpet) | **POST** /pet | Add a new pet to the store
*PetApi* | [**deletePet**](docs/Api/PetApi.md#deletepet) | **DELETE** /pet/{petId} | Deletes a pet
*PetApi* | [**feedPet**](docs/Api/PetApi.md#feedpet) | **POST** /pet/feed/{petId} | Find pet by ID
*PetApi* | [**findPetsByStatus**](docs/Api/PetApi.md#findpetsbystatus) | **GET** /pet/findByStatus | Finds Pets by status
*PetApi* | [**findPetsByTags**](docs/Api/PetApi.md#findpetsbytags) | **GET** /pet/findByTags | Finds Pets by tags
*PetApi* | [**getParrots**](docs/Api/PetApi.md#getparrots) | **GET** /parrot | get Parrots
*PetApi* | [**getPetById**](docs/Api/PetApi.md#getpetbyid) | **GET** /pet/{petId} | Find pet by ID
*PetApi* | [**updateParrots**](docs/Api/PetApi.md#updateparrots) | **PUT** /parrot | update parrots
*PetApi* | [**updatePet**](docs/Api/PetApi.md#updatepet) | **PUT** /pet | Update an existing pet
*PetApi* | [**updatePetWithForm**](docs/Api/PetApi.md#updatepetwithform) | **POST** /pet/{petId} | Updates a pet in the store with form data
*PetApi* | [**uploadFile**](docs/Api/PetApi.md#uploadfile) | **POST** /pet/{petId}/uploadImage | uploads an image
*StoreApi* | [**deleteOrder**](docs/Api/StoreApi.md#deleteorder) | **DELETE** /store/order/{orderId} | Delete purchase order by ID
*StoreApi* | [**getInventory**](docs/Api/StoreApi.md#getinventory) | **GET** /store/inventory | Returns pet inventories by status
*StoreApi* | [**getOrderById**](docs/Api/StoreApi.md#getorderbyid) | **GET** /store/order/{orderId} | Find purchase order by ID
*StoreApi* | [**placeOrder**](docs/Api/StoreApi.md#placeorder) | **POST** /store/order | Place an order for a pet
*UserApi* | [**createUser**](docs/Api/UserApi.md#createuser) | **POST** /user | Create user
*UserApi* | [**createUsersWithArrayInput**](docs/Api/UserApi.md#createuserswitharrayinput) | **POST** /user/createWithArray | Creates list of users with given input array
*UserApi* | [**createUsersWithListInput**](docs/Api/UserApi.md#createuserswithlistinput) | **POST** /user/createWithList | Creates list of users with given input array
*UserApi* | [**deleteUser**](docs/Api/UserApi.md#deleteuser) | **DELETE** /user/{username} | Delete user
*UserApi* | [**getUserByName**](docs/Api/UserApi.md#getuserbyname) | **GET** /user/{username} | Get user by user name
*UserApi* | [**loginUser**](docs/Api/UserApi.md#loginuser) | **GET** /user/login | Logs user into the system
*UserApi* | [**logoutUser**](docs/Api/UserApi.md#logoutuser) | **GET** /user/logout | Logs out current logged in user session
*UserApi* | [**userUsernamePut**](docs/Api/UserApi.md#userusernameput) | **PUT** /user/{username} | Updated user

## Documentation For Models

 - [AllPetsResponse](docs/Model/AllPetsResponse.md)
 - [AnyOfbody1ParrotsItems](docs/Model/AnyOfbody1ParrotsItems.md)
 - [AnyOfbody2](docs/Model/AnyOfbody2.md)
 - [ApiResponse](docs/Model/ApiResponse.md)
 - [Body](docs/Model/Body.md)
 - [Body1](docs/Model/Body1.md)
 - [Body2](docs/Model/Body2.md)
 - [Cat](docs/Model/Cat.md)
 - [Category](docs/Model/Category.md)
 - [Dog](docs/Model/Dog.md)
 - [InlineResponse200](docs/Model/InlineResponse200.md)
 - [InlineResponse2001](docs/Model/InlineResponse2001.md)
 - [Macaw](docs/Model/Macaw.md)
 - [OneOfAllPetsResponseItems](docs/Model/OneOfAllPetsResponseItems.md)
 - [OneOfPartMasterDestination](docs/Model/OneOfPartMasterDestination.md)
 - [OneOfPartMasterOrigin](docs/Model/OneOfPartMasterOrigin.md)
 - [OneOfPetPartItems](docs/Model/OneOfPetPartItems.md)
 - [OneOfPup](docs/Model/OneOfPup.md)
 - [OneOfinlineResponse2001](docs/Model/OneOfinlineResponse2001.md)
 - [OneOfinlineResponse200ParrotsItems](docs/Model/OneOfinlineResponse200ParrotsItems.md)
 - [OneOfvalMembersValMemberItems](docs/Model/OneOfvalMembersValMemberItems.md)
 - [Order](docs/Model/Order.md)
 - [Parakeet](docs/Model/Parakeet.md)
 - [PartFour](docs/Model/PartFour.md)
 - [PartMaster](docs/Model/PartMaster.md)
 - [PartOne](docs/Model/PartOne.md)
 - [PartThree](docs/Model/PartThree.md)
 - [PartTwo](docs/Model/PartTwo.md)
 - [Pet](docs/Model/Pet.md)
 - [Pup](docs/Model/Pup.md)
 - [Tag](docs/Model/Tag.md)
 - [Test](docs/Model/Test.md)
 - [User](docs/Model/User.md)
 - [ValMemberChoice1](docs/Model/ValMemberChoice1.md)
 - [ValMemberChoice2](docs/Model/ValMemberChoice2.md)
 - [ValMembers](docs/Model/ValMembers.md)

## Documentation For Authorization


## api_key

- **Type**: API key
- **API key parameter name**: api_key
- **Location**: HTTP header

## bearer

- **Type**: HTTP bearer authentication

## petstore_auth

- **Type**: OAuth
- **Flow**: implicit
- **Authorization URL**: http://petstore.swagger.io/oauth/dialog
- **Scopes**: 
 - ****: 


## Author

apiteam@swagger.io

